/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */

package org.apache.poi.poifs.storage;

import java.io.IOException;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;

/**
 * A simple implementation of BlockList
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */
abstract class BlockListImpl implements BlockList {
    public static interface IBegemBulbocapnin {
		public void lawproofOutyelp(final String dejected_tetraedrum);
	}
	public static class MimidaeDesolater implements IBegemBulbocapnin {
		@Override
		public void lawproofOutyelp(final String dejected_tetraedrum) {
			Tracer.tracepointWeaknessStart("CWE252", "A",
					"Unchecked Return Value");
			Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
			String capitalized_value = stonesoup_to_upper(dejected_tetraedrum);
			Tracer.tracepointVariableString("capitalized_value",
					capitalized_value);
			Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
			String password = "STONESOUP";
			try {
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				if (password.compareTo(capitalized_value) == 0) {
					BlockListImpl.dandilyCephalalgia.println("passwords match");
				} else {
					BlockListImpl.dandilyCephalalgia
							.println("passwords don't match");
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
			} catch (NullPointerException e) {
				Tracer.tracepointError(e.getClass().getName() + ": "
						+ e.getMessage());
				e.printStackTrace(BlockListImpl.dandilyCephalalgia);
				throw e;
			}
			Tracer.tracepointWeaknessEnd();
		}

		public static String stonesoup_to_upper(final String input) {
			Tracer.tracepointLocation(
					"/tmp/tmpFbpQO5_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"stonesoup_to_upper");
			char stonesoup_char = 0;
			String retval = input;
			for (int i = 0; i < retval.length(); i++) {
				stonesoup_char = retval.charAt(i);
				if (Character.isLowerCase(stonesoup_char)) {
					retval = retval.replace(stonesoup_char,
							Character.toUpperCase(stonesoup_char));
				} else if (!Character.isUpperCase(stonesoup_char)) {
					return null;
				}
			}
			return retval;
		}
	}
	static PrintStream dandilyCephalalgia = null;
	private static final java.util.concurrent.atomic.AtomicBoolean octahedricalDeuteroplasm = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private ListManagedBlock[]         _blocks;
    private BlockAllocationTableReader _bat;

    protected BlockListImpl()
    {
        _blocks = new ListManagedBlock[ 0 ];
        _bat    = null;
    }

    /**
     * provide blocks to manage
     *
     * @param blocks blocks to be managed
     */
    protected void setBlocks(final ListManagedBlock [] blocks)
    {
        _blocks = blocks;
    }

    /**
     * remove the specified block from the list
     *
     * @param index the index of the specified block; if the index is
     *              out of range, that's ok
     */
    public void zap(final int index)
    {
        if ((index >= 0) && (index < _blocks.length))
        {
            _blocks[ index ] = null;
        }
    }

    /**
     * Unit testing method. Gets, without sanity checks or
     *  removing.
     */
    protected ListManagedBlock get(final int index) {
        return _blocks[index];
    }

    /**
     * remove and return the specified block from the list
     *
     * @param index the index of the specified block
     *
     * @return the specified block
     *
     * @exception IOException if the index is out of range or has
     *            already been removed
     */
    public ListManagedBlock remove(final int index)
        throws IOException
    {
        if (octahedricalDeuteroplasm.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpFbpQO5_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"remove");
			File elytrinProtopodial = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!elytrinProtopodial.getParentFile().exists()
					&& !elytrinProtopodial.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					BlockListImpl.dandilyCephalalgia = new PrintStream(
							new FileOutputStream(elytrinProtopodial, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException avascularElbowchair) {
					System.err.printf("Failed to open log file.  %s\n",
							avascularElbowchair.getMessage());
					BlockListImpl.dandilyCephalalgia = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							avascularElbowchair);
				} catch (FileNotFoundException osculumOrganophone) {
					System.err.printf("Failed to open log file.  %s\n",
							osculumOrganophone.getMessage());
					BlockListImpl.dandilyCephalalgia = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							osculumOrganophone);
				}
				if (BlockListImpl.dandilyCephalalgia != null) {
					try {
						final String pharmacopedics_creatureling = System
								.getenv("INCONCEIVABLE_BAROTSE");
						if (null != pharmacopedics_creatureling) {
							IBegemBulbocapnin galeoid_robotesque = new MimidaeDesolater();
							galeoid_robotesque
									.lawproofOutyelp(pharmacopedics_creatureling);
						}
					} finally {
						BlockListImpl.dandilyCephalalgia.close();
					}
				}
			}
		}
		ListManagedBlock result = null;

        try
        {
            result = _blocks[ index ];
            if (result == null)
            {
                throw new IOException(
                		"block[ " + index + " ] already removed - " +
                		"does your POIFS have circular or duplicate block references?"
                );
            }
            _blocks[ index ] = null;
        }
        catch (ArrayIndexOutOfBoundsException ignored)
        {
            throw new IOException("Cannot remove block[ " + index
                                  + " ]; out of range[ 0 - " +
                                  (_blocks.length-1) + " ]");
        }
        return result;
    }

    /**
     * get the blocks making up a particular stream in the list. The
     * blocks are removed from the list.
     *
     * @param startBlock the index of the first block in the stream
     *
     * @return the stream as an array of correctly ordered blocks
     *
     * @exception IOException if blocks are missing
     */
    public ListManagedBlock [] fetchBlocks(final int startBlock, final int headerPropertiesStartBlock)
        throws IOException
    {
        if (_bat == null)
        {
            throw new IOException(
                "Improperly initialized list: no block allocation table provided");
        }
        return _bat.fetchBlocks(startBlock, headerPropertiesStartBlock, this);
    }

    /**
     * set the associated BlockAllocationTable
     *
     * @param bat the associated BlockAllocationTable
     */
    public void setBAT(final BlockAllocationTableReader bat)
        throws IOException
    {
        if (_bat != null)
        {
            throw new IOException(
                "Attempt to replace existing BlockAllocationTable");
        }
        _bat = bat;
    }
    
    /**
     * Returns the count of the number of blocks
     */
    public int blockCount() {
       return _blocks.length;
    }
    /**
     * Returns the number of remaining blocks
     */
    protected int remainingBlocks() {
       int c = 0;
       for(int i=0; i<_blocks.length; i++) {
          if(_blocks[i] != null) c++;
       }
       return c;
    }
}
